// UsersDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "FileZilla server.h"
#include "UsersDlg.h"
#include "misc\md5.h"
#include "misc\sbdestination.h"
#include "entersomething.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CUsersDlg 

t_user& t_user::operator=(const t_user &a)
{
	user=a.user;
	password=a.password;
	bLnk=a.bLnk;
	bRelative=a.bRelative;
	bBypassUserLimit=a.bBypassUserLimit;
	nUserLimit=a.nUserLimit;
	nIpLimit=a.nIpLimit;
	for (int i=0;i<a.permissions.GetSize();i++)
		permissions.Add(a.permissions[i]);
	return *this;
}

CUsersDlg::CUsersDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUsersDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUsersDlg)
	m_bNeedpass = FALSE;
	m_Pass = _T("");
	m_bDirsCreate = FALSE;
	m_bDirsDelete = FALSE;
	m_bDirsList = FALSE;
	m_bDirsSubdirs = FALSE;
	m_bFilesAppend = FALSE;
	m_bFilesDelete = FALSE;
	m_bFilesRead = FALSE;
	m_bFilesWrite = FALSE;
	m_bLnk = FALSE;
	m_bRelative = FALSE;
	m_bMaxUsersBypass = FALSE;
	m_MaxConnCount = _T("");
	m_IpLimit = _T("");
	//}}AFX_DATA_INIT

	HKEY key;
	if (RegOpenKey(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\",&key)==ERROR_SUCCESS)
	{
		char buffer[1000];
		int index=0;
		while (RegEnumKey(key,index,buffer,1000)==ERROR_SUCCESS)
		{
			t_user user;
			user.user=buffer;

			// Look for domain users before non-domain users
			if (!GetDomainUsers(user.user))
			{
				user.password=GetKey(user.user,"Pass");
				user.bLnk=GetKey(user.user,"Resolve Shortcuts")=="1";
				user.bRelative=GetKey(user.user,"Relative")=="1";
				user.bBypassUserLimit=GetKey(user.user,"Bypass server userlimit")=="1";
				user.nUserLimit=atoi(GetKey(user.user,"User Limit"));
				if (user.nUserLimit<0 || user.nUserLimit>999999999)
					user.nUserLimit=0;
				user.nIpLimit=atoi(GetKey(user.user,"IP Limit"));
				if (user.nIpLimit<0 || user.nIpLimit>999999999)
					user.nIpLimit=0;
				ReadPermissions(user);
				m_Users.Add(user);
			}
			index++;
		}
		RegCloseKey(key);
	}
	else
	{
		if (RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users",0,0,REG_OPTION_NON_VOLATILE,KEY_WRITE,0,&key,NULL)==ERROR_SUCCESS) 
		{
			RegCloseKey(key);
		}
	}
	
}

CUsersDlg::~CUsersDlg()
{
	
}

//
// If we are dealing with a domain user the keys in the registry are set up with a parent key indicating
// the domain name and children keys named for the users.  We are passed this key as a potential parent
// (domain) key.  If we find that we do indeed have user keys below it then add the users to m_user
// and return TRUE.  Otherwise just return FALSE.
//
BOOL CUsersDlg::GetDomainUsers(CString DomainKeyName)
{
	HKEY		DomainKey;
	BOOL		FoundADomainUser;		// Our return code

	FoundADomainUser = FALSE;
	if (RegOpenKey(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\" + DomainKeyName,&DomainKey)==ERROR_SUCCESS)
	{
		char buffer[1000];
		int index=0;
		while (RegEnumKey(DomainKey,index,buffer,1000)==ERROR_SUCCESS)
		{
			t_user user;

			user.user=DomainKeyName + "\\" + buffer;
			user.password=GetKey(user.user,"Pass");
			
			// If there are no proper values under this key then we don't have a
			// domain user
			if (GetKey(user.user,"Resolve Shortcuts") != "")
			{
				user.bLnk=GetKey(user.user,"Resolve Shortcuts")=="1";
				user.bRelative=GetKey(user.user,"Relative")=="1";
				user.bBypassUserLimit=GetKey(user.user,"Bypass server userlimit")=="1";
				user.nUserLimit=atoi(GetKey(user.user,"User Limit"));
				if (user.nUserLimit<0 || user.nUserLimit>999999999)
					user.nUserLimit=0;
				user.nIpLimit=atoi(GetKey(user.user,"IP Limit"));
				if (user.nIpLimit<0 || user.nIpLimit>999999999)
					user.nIpLimit=0;
				ReadPermissions(user);
				m_Users.Add(user);
				FoundADomainUser = TRUE;
			}
			index++;
		}
		RegCloseKey(DomainKey);
	}
	return (FoundADomainUser);
}

void CUsersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUsersDlg)
	DDX_Control(pDX, IDC_IPLIMIT, m_cIpLimit);
	DDX_Control(pDX, IDC_MAXCONNCOUNT, m_cMaxConnCount);
	DDX_Control(pDX, IDC_MAXUSERBYPASS, m_cMaxUsersBypass);
	DDX_Control(pDX, IDC_RELATIVE, m_cRelative);
	DDX_Control(pDX, IDC_LNK, m_cLnk);
	DDX_Control(pDX, IDC_NEEDPASS, m_cNeedpass);
	DDX_Control(pDX, IDC_GROUP, m_cGroup);
	DDX_Control(pDX, IDC_DIRS_CREATE, m_cDirsCreate);
	DDX_Control(pDX, IDC_DIRS_DELETE, m_cDirsDelete);
	DDX_Control(pDX, IDC_DIRS_LIST, m_cDirsList);
	DDX_Control(pDX, IDC_DIRS_SUBDIRS, m_cDirsSubdirs);
	DDX_Control(pDX, IDC_FILES_READ, m_cFilesRead);
	DDX_Control(pDX, IDC_FILES_WRITE, m_cFilesWrite);
	DDX_Control(pDX, IDC_FILES_DELETE, m_cFilesDelete);
	DDX_Control(pDX, IDC_FILES_APPEND, m_cFilesAppend);
	DDX_Control(pDX, IDC_DIRS, m_cDirs);
	DDX_Control(pDX, IDC_USERLIST, m_cUserlist);
	DDX_Control(pDX, IDC_PASS, m_cPass);
	DDX_Check(pDX, IDC_NEEDPASS, m_bNeedpass);
	DDX_Text(pDX, IDC_PASS, m_Pass);
	DDX_Check(pDX, IDC_DIRS_CREATE, m_bDirsCreate);
	DDX_Check(pDX, IDC_DIRS_DELETE, m_bDirsDelete);
	DDX_Check(pDX, IDC_DIRS_LIST, m_bDirsList);
	DDX_Check(pDX, IDC_DIRS_SUBDIRS, m_bDirsSubdirs);
	DDX_Check(pDX, IDC_FILES_APPEND, m_bFilesAppend);
	DDX_Check(pDX, IDC_FILES_DELETE, m_bFilesDelete);
	DDX_Check(pDX, IDC_FILES_READ, m_bFilesRead);
	DDX_Check(pDX, IDC_FILES_WRITE, m_bFilesWrite);
	DDX_Check(pDX, IDC_LNK, m_bLnk);
	DDX_Check(pDX, IDC_RELATIVE, m_bRelative);
	DDX_Check(pDX, IDC_MAXUSERBYPASS, m_bMaxUsersBypass);
	DDX_Text(pDX, IDC_MAXCONNCOUNT, m_MaxConnCount);
	DDV_MaxChars(pDX, m_MaxConnCount, 9);
	DDX_Text(pDX, IDC_IPLIMIT, m_IpLimit);
	DDV_MaxChars(pDX, m_IpLimit, 9);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUsersDlg, CDialog)
	//{{AFX_MSG_MAP(CUsersDlg)
	ON_BN_CLICKED(IDC_NEEDPASS, OnNeedpass)
	ON_LBN_SELCHANGE(IDC_USERLIST, OnSelchangeUserlist)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_USERMENU_ADD, OnUsermenuAdd)
	ON_COMMAND(ID_USERMENU_REMOVE, OnUsermenuRemove)
	ON_COMMAND(ID_USERMENU_RENAME, OnUsermenuRename)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_DIRS, OnItemchangedDirs)
	ON_NOTIFY(LVN_ITEMCHANGING, IDC_DIRS, OnItemchangingDirs)
	ON_COMMAND(ID_DIRMENU_ADD, OnDirmenuAdd)
	ON_COMMAND(ID_DIRMENU_REMOVE, OnDirmenuRemove)
	ON_COMMAND(ID_DIRMENU_RENAME, OnDirmenuRename)
	ON_COMMAND(ID_DIRMENU_SETASHOMEDIR, OnDirmenuSetashomedir)
	ON_NOTIFY(LVN_ENDLABELEDIT, IDC_DIRS, OnEndlabeleditDirs)
	ON_NOTIFY(NM_DBLCLK, IDC_DIRS, OnDblclkDirs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CUsersDlg 

BOOL CUsersDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_olduser=LB_ERR;
	m_bNeedpass=FALSE;
	m_Pass="";
	m_cUserlist.ResetContent();	
	m_cDirs.InsertColumn(0,"Directories",LVCFMT_LEFT,142);
	m_cDirs.InsertColumn(1,"Attributes",LVCFMT_LEFT,57);
	UpdateData(FALSE);
	for (int i=0;i<m_UsersTmp.GetSize();i++)
	{
		int index=m_cUserlist.AddString(m_UsersTmp[i].user);
		m_cUserlist.SetItemData(index,i);
	}
	
	static initialized=0;
	if (!initialized)
	{
		initialized=1;
		m_imagelist.Create( 16, 16, ILC_MASK, 3, 3 );
		HICON icon;
		icon=AfxGetApp()->LoadIcon(IDI_EMPTY);
		m_imagelist.Add(icon);
		DestroyIcon(icon);
		icon=AfxGetApp()->LoadIcon(IDI_HOME);
		m_imagelist.Add(icon);
		DestroyIcon(icon);
	}
	m_cDirs.SetImageList(&m_imagelist,LVSIL_SMALL);
			
	SetCtrlState();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

int CUsersDlg::DoModal() 
{
	m_sync.Lock();
	for (int i=0;i<m_Users.GetSize();i++)
	{
		m_UsersTmp.Add(m_Users[i]);
	}
	m_sync.Unlock();
	
	if (CDialog::DoModal()==IDOK)
	{
		m_sync.Lock();
		//Delete the old registry entries
		for (i=0;i<m_Users.GetSize();i++)
		{
			HKEY key;
			if (RegOpenKey(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\"+m_Users[i].user+"\\",&key)==ERROR_SUCCESS)
			{
				char buffer[1000];
				int index=0;
				while (RegEnumKey(key,index,buffer,1000)==ERROR_SUCCESS)
				{
					if (RegDeleteKey(key,buffer)!=ERROR_SUCCESS)
						index++;
				}
				RegCloseKey(key);
			}
			if (RegOpenKey(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\",&key)==ERROR_SUCCESS)
			{
				RegDeleteKey(key,m_Users[i].user);
				RegCloseKey(key);
			}
		}
		
		//Update the account list
		m_Users.RemoveAll();
		for (i=0;i<m_UsersTmp.GetSize();i++)
		{
			m_Users.Add(m_UsersTmp[i]);
		}
		
		m_UsersTmp.RemoveAll();
		
		m_sync.Unlock();
		
		//Save the changed user details
		for (i=0;i<m_Users.GetSize();i++)
		{
			SetKey(m_Users[i].user,"Pass",m_Users[i].password);
			SetKey(m_Users[i].user,"Resolve Shortcuts",m_Users[i].bLnk?"1":"0");
			SetKey(m_Users[i].user,"Relative",m_Users[i].bRelative?"1":"0");
			SetKey(m_Users[i].user,"Bypass server userlimit",m_Users[i].bBypassUserLimit?"1":"0");
			CString str;
			str.Format("%d",m_Users[i].nUserLimit);
			SetKey(m_Users[i].user,"User Limit",str);
			str.Format("%d",m_Users[i].nIpLimit);
			SetKey(m_Users[i].user,"IP Limit",str);
			
			
			SavePermissions(m_Users[i]);
		}
		return IDOK;
	}
	m_UsersTmp.RemoveAll();
	return IDCANCEL;
}

CString CUsersDlg::GetKey(CString subkey,CString keyname)
{
	HKEY key;
	if (RegOpenKey(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\"+subkey,&key)==ERROR_SUCCESS)
	{
		unsigned char *buffer=new unsigned char[100];
		memset(buffer,0,100);
	
		unsigned long tmp=100;
		if (RegQueryValueEx(key,keyname,NULL,NULL,buffer,&tmp)!=ERROR_SUCCESS) 
		{
			RegCloseKey(key);
			delete [] buffer;
			return "";
		}
		else 
		{
			RegCloseKey(key);
			CString res=buffer;
			delete [] buffer;
			return res;
		}
	}
	return "";
}

void CUsersDlg::SetKey(CString subkey,CString keyname,CString value)
{
	char *tmp=new char[value.GetLength()+1];
	LPCSTR str=value;
	strcpy(tmp,str);
	HKEY key;
	if (RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\"+subkey,0,0,REG_OPTION_NON_VOLATILE,KEY_WRITE,0,&key,NULL)==ERROR_SUCCESS) 
	{
		RegSetValueEx(key,keyname,0,REG_SZ,(unsigned char *)tmp,value.GetLength()+1);
		RegCloseKey(key);
	}
	delete [] tmp;
}


BOOL CUsersDlg::Lookup(const CString &user, const CString &pass,t_user &userdata)
{
	const char *tmp=pass;
	MD5 md5;
	md5.update((unsigned char *)tmp,pass.GetLength());
	md5.finalize();
	char *res=md5.hex_digest();
	CString hash=res;
	delete [] res;
	m_sync.Lock();
	for (int i=0;i<m_Users.GetSize();i++)
	{
		if (m_Users[i].user==user)
		{
			if (m_Users[i].password==hash || m_Users[i].password=="")
			{
				userdata=m_Users[i];
				m_sync.Unlock();
				return TRUE;
			}
			else
			{
				m_sync.Unlock();
				return FALSE;
			}
		}
	}
	m_sync.Unlock();
	return FALSE;
}

void CUsersDlg::OnNeedpass() 
{
	UpdateData(TRUE);
	m_cPass.EnableWindow(m_bNeedpass);
}

BOOL CUsersDlg::Validate()
{
	//TODO: check for homedir
	
	UpdateData(TRUE);
	if (m_bNeedpass && m_Pass=="")
	{
		m_cUserlist.SetCurSel(m_olduser);
		m_cPass.SetFocus();
		AfxMessageBox("Empty passwords are not allowed. Please enter a password!");
		return FALSE;
	}
	if (atoi(m_MaxConnCount)<0 || atoi(m_MaxConnCount)>999999999)
	{
		m_cUserlist.SetCurSel(m_olduser);
		m_cMaxConnCount.SetFocus();
		AfxMessageBox("The maximum user count has to be between 0 and 999999999!");
		return FALSE;
	}
	if (atoi(m_MaxConnCount)<0 || atoi(m_MaxConnCount)>999999999)
	{
		m_cUserlist.SetCurSel(m_olduser);
		m_cIpLimit.SetFocus();
		AfxMessageBox("The maximum user limit per IP has to be between 0 and 999999999!");
		return FALSE;
	}
	return TRUE;
}

void CUsersDlg::OnSelchangeUserlist() 
{
	if (!Validate())
		return;
	if (m_olduser!=LB_ERR)
	{
		int oldindex=m_cUserlist.GetItemData(m_olduser);
		m_UsersTmp[oldindex].password=m_Pass;
		if (!m_bNeedpass)
			m_UsersTmp[oldindex].password="";
		else if (m_cPass.GetModify() && m_Pass!="")
		{
			const char *tmp=m_UsersTmp[oldindex].password;
			MD5 md5;
			md5.update((unsigned char *)tmp,m_UsersTmp[oldindex].password.GetLength());
			md5.finalize();
			char *res=md5.hex_digest();
			CString hash=res;
			delete [] res;
			m_UsersTmp[oldindex].password=hash;	
		}
		
		m_UsersTmp[oldindex].bLnk=m_bLnk;
		m_UsersTmp[oldindex].bRelative=m_bRelative;
		m_UsersTmp[oldindex].bBypassUserLimit=m_bMaxUsersBypass;
		m_UsersTmp[oldindex].nUserLimit=atoi(m_MaxConnCount);
		m_UsersTmp[oldindex].nIpLimit=atoi(m_IpLimit);
		POSITION selpos=m_cDirs.GetFirstSelectedItemPosition();
		if (selpos)
		{
			int item=m_cDirs.GetNextSelectedItem(selpos);
			int index=m_cDirs.GetItemData(item);
			m_UsersTmp[oldindex].permissions[index].bFileRead=m_bFilesRead;
			m_UsersTmp[oldindex].permissions[index].bFileWrite=m_bFilesWrite;
			m_UsersTmp[oldindex].permissions[index].bFileDelete=m_bFilesDelete;
			m_UsersTmp[oldindex].permissions[index].bFileAppend=m_bFilesAppend;
			m_UsersTmp[oldindex].permissions[index].bDirCreate=m_bDirsCreate;
			m_UsersTmp[oldindex].permissions[index].bDirDelete=m_bDirsDelete;
			m_UsersTmp[oldindex].permissions[index].bDirList=m_bDirsList;
			m_UsersTmp[oldindex].permissions[index].bDirSubdirs=m_bDirsSubdirs;
		}		
	
	}
	int nItem=m_cUserlist.GetCurSel();
	if (nItem!=LB_ERR)
	{
		m_olduser=nItem;
		int index=m_cUserlist.GetItemData(nItem);
		m_Pass=m_UsersTmp[index].password;
		m_cPass.SetModify(FALSE);
		m_bNeedpass=m_UsersTmp[index].password!="";
		m_bLnk=m_UsersTmp[index].bLnk;
		m_bRelative=m_UsersTmp[index].bRelative;
		m_bMaxUsersBypass=m_UsersTmp[index].bBypassUserLimit;
		CString str;
		str.Format("%d",m_UsersTmp[index].nUserLimit);
		m_MaxConnCount=str;
		str.Format("%d",m_UsersTmp[index].nIpLimit);
		m_IpLimit=str;
		UpdateData(FALSE);

		//Fill the dirs list
		m_cDirs.DeleteAllItems();
		for (int j=0;j<m_UsersTmp[index].permissions.GetSize();j++)
		{
			int nItem=m_cDirs.InsertItem(j,m_UsersTmp[index].permissions[j].dir);
			LVITEM item;
			memset(&item,0,sizeof(item));
			item.mask=LVIF_IMAGE|LVIF_PARAM;
			item.iItem=nItem;
			m_cDirs.GetItem(&item);
			item.lParam=j;
			item.iImage=m_UsersTmp[index].permissions[j].bIsHome?1:0;
			m_cDirs.SetItem(&item);
		}
	}
	else
	{
		m_cDirs.DeleteAllItems();
		m_bNeedpass=FALSE;
		m_Pass="";
		m_bRelative=FALSE;
		m_bLnk=FALSE;
		m_bMaxUsersBypass=FALSE;
		m_IpLimit="";
		m_MaxConnCount="";
		m_bFilesRead=m_bFilesWrite=m_bFilesDelete=m_bFilesAppend=FALSE;
		m_bDirsCreate=m_bDirsList=m_bDirsDelete=m_bDirsSubdirs=FALSE;
	}
	UpdateData(FALSE);

	SetCtrlState();
}

void CUsersDlg::OnOK() 
{
	if (!Validate())
		return;
	m_cUserlist.SetCurSel(-1);
	OnSelchangeUserlist();
	
	CDialog::OnOK();
}

void CUsersDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	if (pWnd==&m_cUserlist)
	{
		CMenu menu;
		menu.LoadMenu(IDR_USERCONTEXT);

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;
		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();
		
		if (m_cUserlist.GetCurSel()==LB_ERR)
		{
			pPopup->EnableMenuItem(ID_USERMENU_REMOVE,MF_GRAYED);
			pPopup->EnableMenuItem(ID_USERMENU_RENAME,MF_GRAYED);
		}
		if (point.x==-1)
			GetCursorPos(&point);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
	else if (pWnd==&m_cDirs)
	{
		CMenu menu;
		menu.LoadMenu(IDR_DIRCONTEXT);

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;
		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();
		
		if (!m_cDirs.GetFirstSelectedItemPosition())
		{
			pPopup->EnableMenuItem(ID_DIRMENU_REMOVE,MF_GRAYED);
			pPopup->EnableMenuItem(ID_DIRMENU_RENAME,MF_GRAYED);
			pPopup->EnableMenuItem(ID_DIRMENU_SETASHOMEDIR,MF_GRAYED);
		}
		if (point.x==-1)
			GetCursorPos(&point);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}

void CUsersDlg::OnUsermenuAdd() 
{
	if (!Validate())
		return;

	CEnterSomething dlg(IDS_ADDUSERDIALOG);
	if (dlg.DoModal()==IDOK)
	{
		CString newname=dlg.m_String;
		newname.MakeLower();
		for (int i=0;i<m_cUserlist.GetCount();i++)
		{
			CString str;
			m_cUserlist.GetText(i,str);
			str.MakeLower();
			if (str==newname)
			{
				AfxMessageBox(IDS_ERRORMSG_USERALREADYEXISTS);
				return;
			}
		}

		t_user user;
		user.user=dlg.m_String;
		user.bBypassUserLimit=FALSE;
		user.bLnk=FALSE;
		user.bRelative=FALSE;
		user.nIpLimit=0;
		user.nUserLimit=0;
		user.password="";
		int nItem=m_cUserlist.AddString(user.user);
		if (nItem<=m_olduser)
			m_olduser++;
		int index=m_UsersTmp.Add(user);
		m_cUserlist.SetItemData(nItem,index);
		m_cUserlist.SetCurSel(nItem);	
		OnSelchangeUserlist();
	}
}

void CUsersDlg::OnUsermenuRemove() 
{
	int pos=m_cUserlist.GetCurSel();
	if (pos==LB_ERR)
		return;
	int index=m_cUserlist.GetItemData(pos);
	m_cUserlist.DeleteString(pos);
	m_UsersTmp.RemoveAt(index);
	m_olduser=LB_ERR;
	for (int i=0;i<m_cUserlist.GetCount();i++)
	{
		int data=m_cUserlist.GetItemData(i);
		if (data>pos)
			m_cUserlist.SetItemData(i,data-1);
	}
	OnSelchangeUserlist();
}

void CUsersDlg::OnUsermenuRename() 
{
	if (!Validate())
		return;

	int pos=m_cUserlist.GetCurSel();
	if (pos==LB_ERR)
		return;
	int index=m_cUserlist.GetItemData(pos);

	CEnterSomething dlg(IDS_INPUTDIALOGTEXT_RENAME);
	if (dlg.DoModal()==IDOK)
	{
		CString newname=dlg.m_String;
		newname.MakeLower();
		for (int i=0;i<m_cUserlist.GetCount();i++)
		{
			CString str;
			m_cUserlist.GetText(i,str);
			str.MakeLower();
			if (str==newname)
			{
				AfxMessageBox(IDS_ERRORMSG_USERALREADYEXISTS);
				return;
			}
		}
		
		m_cUserlist.DeleteString(pos);
		pos=m_cUserlist.AddString(dlg.m_String);
		m_cUserlist.SetItemData(pos,index);
		m_cUserlist.SetCurSel(pos);	
		m_olduser=pos;
		m_UsersTmp[index].user=dlg.m_String;
		OnSelchangeUserlist();
	}
}

void CUsersDlg::ReadPermissions(t_user &user)
{
	HKEY key;
	if (RegOpenKey(HKEY_CURRENT_USER,"Software\\FileZilla Server\\Users\\"+user.user+"\\",&key)==ERROR_SUCCESS)
	{
		char buffer[1000];
		int index=0;
		while (RegEnumKey(key,index,buffer,1000)==ERROR_SUCCESS)
		{
			CString buffer2=buffer;
			t_directory dir;
			dir.dir=GetKey(user.user+"\\"+buffer2,"");
			dir.bFileRead=GetKey(user.user+"\\"+buffer2,"FileRead")=="1";
			dir.bFileWrite=GetKey(user.user+"\\"+buffer2,"FileWrite")=="1";
			dir.bFileDelete=GetKey(user.user+"\\"+buffer2,"FileDelete")=="1";
			dir.bFileAppend=GetKey(user.user+"\\"+buffer2,"FileAppend")=="1";
			dir.bDirCreate=GetKey(user.user+"\\"+buffer2,"DirCreate")=="1";
			dir.bDirDelete=GetKey(user.user+"\\"+buffer2,"DirDelete")=="1";
			dir.bDirList=GetKey(user.user+"\\"+buffer2,"DirList")=="1";
			dir.bDirSubdirs=GetKey(user.user+"\\"+buffer2,"DirSubdirs")=="1";
			dir.bIsHome=GetKey(user.user+"\\"+buffer2,"IsHome")=="1";
			user.permissions.Add(dir);
			index++;
		}
		RegCloseKey(key);
	}
}

void CUsersDlg::SavePermissions(t_user &user)
{
	for (int i=0;i<user.permissions.GetSize();i++)
	{
		CString num;
		num.Format("%d",i+1);

		SetKey(user.user+"\\"+num,"",user.permissions[i].dir);
		SetKey(user.user+"\\"+num,"FileRead",user.permissions[i].bFileRead?"1":"0");
		SetKey(user.user+"\\"+num,"FileWrite",user.permissions[i].bFileWrite?"1":"0");
		SetKey(user.user+"\\"+num,"FileDelete",user.permissions[i].bFileDelete?"1":"0");
		SetKey(user.user+"\\"+num,"FileAppend",user.permissions[i].bFileAppend?"1":"0");
		SetKey(user.user+"\\"+num,"DirCreate",user.permissions[i].bDirCreate?"1":"0");
		SetKey(user.user+"\\"+num,"DirDelete",user.permissions[i].bDirDelete?"1":"0");
		SetKey(user.user+"\\"+num,"DirList",user.permissions[i].bDirList?"1":"0");
		SetKey(user.user+"\\"+num,"DirSubdirs",user.permissions[i].bDirSubdirs?"1":"0");	
		SetKey(user.user+"\\"+num,"IsHome",user.permissions[i].bIsHome?"1":"0");	
	}
}

void CUsersDlg::OnItemchangedDirs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	int useritem=m_cUserlist.GetCurSel();
	if (useritem==LB_ERR)
		return;
	int userindex=m_cUserlist.GetItemData(useritem);
	
	int nItem=pNMListView->iItem;
	int index=pNMListView->lParam;
	if (nItem!=-1)
	{
		m_bFilesRead=m_UsersTmp[userindex].permissions[index].bFileRead;
		m_bFilesWrite=m_UsersTmp[userindex].permissions[index].bFileWrite;
		m_bFilesDelete=m_UsersTmp[userindex].permissions[index].bFileDelete;
		m_bFilesAppend=m_UsersTmp[userindex].permissions[index].bFileAppend;
		m_bDirsCreate=m_UsersTmp[userindex].permissions[index].bDirCreate;
		m_bDirsDelete=m_UsersTmp[userindex].permissions[index].bDirDelete;
		m_bDirsList=m_UsersTmp[userindex].permissions[index].bDirList;
		m_bDirsSubdirs=m_UsersTmp[userindex].permissions[index].bDirSubdirs;
	}
	UpdateData(FALSE);

	SetCtrlState();	
	*pResult = 0;
}

void CUsersDlg::OnItemchangingDirs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	UpdateData(TRUE);
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	int useritem=m_cUserlist.GetCurSel();
	if (useritem==LB_ERR)
		return;
	int userindex=m_cUserlist.GetItemData(useritem);
		
	POSITION selpos=m_cDirs.GetFirstSelectedItemPosition();
	if (selpos)
	{
		int item=m_cDirs.GetNextSelectedItem(selpos);
		int index=m_cDirs.GetItemData(item);
		m_UsersTmp[userindex].permissions[index].bFileRead=m_bFilesRead;
		m_UsersTmp[userindex].permissions[index].bFileWrite=m_bFilesWrite;
		m_UsersTmp[userindex].permissions[index].bFileDelete=m_bFilesDelete;
		m_UsersTmp[userindex].permissions[index].bFileAppend=m_bFilesAppend;
		m_UsersTmp[userindex].permissions[index].bDirCreate=m_bDirsCreate;
		m_UsersTmp[userindex].permissions[index].bDirDelete=m_bDirsDelete;
		m_UsersTmp[userindex].permissions[index].bDirList=m_bDirsList;
		m_UsersTmp[userindex].permissions[index].bDirSubdirs=m_bDirsSubdirs;
	}
}

void CUsersDlg::SetCtrlState()
{
	if (m_cUserlist.GetCurSel()==LB_ERR)
	{
		m_cNeedpass.EnableWindow(FALSE);
		m_cPass.EnableWindow(FALSE);
		m_cGroup.EnableWindow(FALSE);
		m_cDirs.EnableWindow(FALSE);
		m_cFilesRead.EnableWindow(FALSE);
		m_cFilesWrite.EnableWindow(FALSE);
		m_cFilesDelete.EnableWindow(FALSE);
		m_cFilesAppend.EnableWindow(FALSE);
		m_cDirsCreate.EnableWindow(FALSE);
		m_cDirsDelete.EnableWindow(FALSE);
		m_cDirsList.EnableWindow(FALSE);
		m_cDirsSubdirs.EnableWindow(FALSE);
		m_cLnk.EnableWindow(FALSE);
		m_cRelative.EnableWindow(FALSE);
		m_cMaxUsersBypass.EnableWindow(FALSE);
		m_cMaxConnCount.EnableWindow(FALSE);
		m_cIpLimit.EnableWindow(FALSE);
	}
	else
	{
		m_cNeedpass.EnableWindow(TRUE);
		m_cPass.EnableWindow(TRUE);
		m_cGroup.EnableWindow(TRUE);
		m_cDirs.EnableWindow(TRUE);
		m_cLnk.EnableWindow(TRUE);
		m_cRelative.EnableWindow(TRUE);
		m_cMaxUsersBypass.EnableWindow(TRUE);
		m_cMaxConnCount.EnableWindow(TRUE);
		m_cIpLimit.EnableWindow(TRUE);
		if (m_cDirs.GetFirstSelectedItemPosition())
		{
			m_cFilesRead.EnableWindow(TRUE);
			m_cFilesWrite.EnableWindow(TRUE);
			m_cFilesDelete.EnableWindow(TRUE);
			m_cFilesAppend.EnableWindow(TRUE);
			m_cDirsCreate.EnableWindow(TRUE);
			m_cDirsDelete.EnableWindow(TRUE);
			m_cDirsList.EnableWindow(TRUE);
			m_cDirsSubdirs.EnableWindow(TRUE);
		}
		else
		{
			m_cFilesRead.EnableWindow(FALSE);
			m_cFilesWrite.EnableWindow(FALSE);
			m_cFilesDelete.EnableWindow(FALSE);
			m_cFilesAppend.EnableWindow(FALSE);
			m_cDirsCreate.EnableWindow(FALSE);
			m_cDirsDelete.EnableWindow(FALSE);
			m_cDirsList.EnableWindow(FALSE);
			m_cDirsSubdirs.EnableWindow(FALSE);
		}
		OnNeedpass();
	}
}

void CUsersDlg::OnDirmenuAdd() 
{
	int pos=m_cUserlist.GetCurSel();
	if (pos==-1)
		return;
	int userindex=m_cUserlist.GetItemData(pos);
	t_directory dir;
	dir.bDirCreate=dir.bDirDelete=dir.bDirList=
		dir.bDirSubdirs=dir.bFileAppend=
		dir.bFileDelete=dir.bFileRead=
		dir.bFileWrite=dir.bIsHome=FALSE;
	dir.dir="";
	dir.bIsHome=m_cDirs.GetItemCount()?FALSE:TRUE;

	int index=m_UsersTmp[userindex].permissions.Add(dir);
	int nItem=m_cDirs.InsertItem(LVIF_TEXT |LVIF_PARAM|LVIF_IMAGE,0,"",0,0,dir.bIsHome?1:0,index);
	m_cDirs.SetItemState(nItem,LVIS_SELECTED,LVIS_SELECTED);
	m_cDirs.SetItemState(nItem,LVIS_SELECTED,LVIS_SELECTED);
	OnDirmenuRename();	
}

void CUsersDlg::OnDirmenuRemove() 
{
	int useritem=m_cUserlist.GetCurSel();
	if (useritem==LB_ERR)
		return;
	int userindex=m_cUserlist.GetItemData(useritem);
	POSITION selpos;
	selpos=m_cDirs.GetFirstSelectedItemPosition();
	if (!selpos)
		return;
	int nItem=m_cDirs.GetNextSelectedItem(selpos);
	int index=m_cDirs.GetItemData(nItem);
	m_cDirs.DeleteItem(nItem);
	m_UsersTmp[userindex].permissions.RemoveAt(index);
	for (int i=0;i<m_cDirs.GetItemCount();i++)
	{
		int data=m_cDirs.GetItemData(i);
		if (data>index)
		{
			m_cDirs.SetItemData(i,data-1);
		}
	}
	SetCtrlState();
}

void CUsersDlg::OnDirmenuRename() 
{
	int pos=m_cUserlist.GetCurSel();
	if (pos==-1)
		return;
	POSITION selpos=m_cDirs.GetFirstSelectedItemPosition();
	if (!selpos)
		return;
	int nItem=m_cDirs.GetNextSelectedItem(selpos);
		
	m_cDirs.EditLabel(nItem);
		
}

void CUsersDlg::OnDirmenuSetashomedir() 
{
	int	useritem=m_cUserlist.GetCurSel();
	if (useritem==LB_ERR)
		return;
	int userindex=m_cUserlist.GetItemData(useritem);
	POSITION selpos;
	selpos=m_cDirs.GetFirstSelectedItemPosition();
	if (!selpos)
		return;
	int nItem=m_cDirs.GetNextSelectedItem(selpos);
	
	for (int j=0;j<m_UsersTmp[userindex].permissions.GetSize();j++)
	{
		LVITEM item;
		memset(&item,0,sizeof(item));
		item.mask=LVIF_IMAGE|LVIF_PARAM;
		item.iItem=j;
		m_cDirs.GetItem(&item);
		item.iImage=(j==nItem)?1:0;
		m_UsersTmp[userindex].permissions[item.lParam].bIsHome=0;
		m_cDirs.SetItem(&item);
	}
	int index=m_cDirs.GetItemData(nItem);
	m_UsersTmp[userindex].permissions[index].bIsHome=1;

}

void CUsersDlg::OnEndlabeleditDirs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	if (pDispInfo->item.pszText)
	{
		if (pDispInfo->item.pszText[0]==0)
		{
			AfxMessageBox("Please select a folder!");
			*pResult=FALSE;
		}
		else
		{
			int pos=m_cUserlist.GetCurSel();
			if (pos==-1)
				return;
			int userindex=m_cUserlist.GetItemData(pos);
			m_UsersTmp[userindex].permissions[pDispInfo->item.lParam].dir=pDispInfo->item.pszText;
			*pResult=TRUE;
		}
	
	}
	else
	{
		if (m_cDirs.GetItemText(pDispInfo->item.iItem,0)=="")
		{
			int pos=m_cUserlist.GetCurSel();
			if (pos==-1)
				return;
			int userindex=m_cUserlist.GetItemData(pos);
	
			m_cDirs.DeleteItem(pDispInfo->item.iItem);
			m_UsersTmp[userindex].permissions.RemoveAt(pDispInfo->item.lParam);
		}
	}
}

void CUsersDlg::OnDblclkDirs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int pos=m_cUserlist.GetCurSel();
	if (pos==-1)
		return;
	int userindex=m_cUserlist.GetItemData(pos);
	POSITION selpos=m_cDirs.GetFirstSelectedItemPosition();
	if (!selpos)
		return;
	int nItem=m_cDirs.GetNextSelectedItem(selpos);
	int index=m_cDirs.GetItemData(nItem);
	CSBDestination sb(m_hWnd, IDS_BROWSEFORFOLDER);
	sb.SetFlags(BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT);
	sb.SetInitialSelection(m_cDirs.GetItemText(nItem,0));
	if (sb.SelectFolder())
	{
		m_cDirs.SetItemText(nItem,0,sb.GetSelectedFolder());
		m_UsersTmp[userindex].permissions[index].dir=sb.GetSelectedFolder();
	}
	
	
	*pResult = 0;
}

CString CUsersDlg::GetHomeDir(CString user)
{
	m_sync.Lock();
	for (int index=0;index<m_Users.GetSize();index++)
	{
		if (m_Users[index].user==user)
			break;
	}
	if (index==m_Users.GetSize())
		return "";
	BOOL bRelative=m_Users[index].bRelative;
	m_sync.Unlock();

	if (!bRelative)
	{
		m_sync.Lock();
		for (int i=0;i<m_Users[index].permissions.GetSize();i++)
		{
			if (m_Users[index].permissions[i].bIsHome)
				break;
		}
		if (i==m_Users[index].permissions.GetSize())
		{
			m_sync.Unlock();
			return "";
		}
		CString path=m_Users[index].permissions[i].dir;
		m_sync.Unlock();
		path.Replace("\\","/");
		path.TrimRight("/");
		path="/"+path;
		return path;
		
	}
	return "/";
	
}

int CUsersDlg::GetDirectoryListing(CString user, CString dir, CString &result)
{
	m_sync.Lock();
	for (int index=0;index<m_Users.GetSize();index++)
	{
		if (m_Users[index].user==user)
			break;
	}
	if (index==m_Users.GetSize())
		return 1;
	BOOL bRelative=m_Users[index].bRelative;
	m_sync.Unlock();
	t_directory directory;
	BOOL bTmp;
	int res=GetRealDirectory(dir,index,directory,bTmp);
	if (res)
		return res;

	//Allocate 5000 bytes for result
	//This way, += operations to result are faster since no new memory has to be 
	//allocated most of the time.
	int reflen=5000;
	result.GetBuffer(reflen);
	result.ReleaseBuffer();
	result="";
	CFileFind find;
	BOOL found=find.FindFile(directory.dir+"\\*.*");
	while (found)
	{
		found=find.FindNextFile();
		if (find.IsDots())
			continue;
		CString fn=find.GetFileName();
		CString fn2=fn;
		fn2.MakeLower();
		
		if (find.IsDirectory())
			result+="drwxr-xr-x";
		else if (!find.IsDirectory() && fn2.Right(4)==".lnk" && m_Users[index].bLnk)
		{
			if (bRelative)
			{
				fn=fn.Left(fn.GetLength()-4);
				t_directory directory;
				BOOL truematch;
				if (GetRealDirectory(dir+"/"+fn,index,directory,truematch))
					continue;
				if (!directory.bDirList)
					continue;
				if (!truematch && !directory.bDirSubdirs)
					continue;
				result+="drwxr-xr-x";
			}
			else
			{
				CString lnkpath=GetShortcutTarget(find.GetFilePath());
				if (lnkpath=="")
					continue;
				lnkpath.Replace("\\","/");
				lnkpath.TrimRight("/");
				fn=fn.Left(fn.GetLength()-4);
				
				t_directory directory;
				BOOL truematch;
				if (GetRealDirectory("/"+lnkpath,index,directory,truematch))
					continue;
				if (!directory.bDirList)
					continue;
				if (!truematch && !directory.bDirSubdirs)
					continue;
				result+="lrwxr-xr-x";
				directory.dir.Replace("\\","/");
				directory.dir.TrimRight("/");
				fn=fn+" -> "+"/"+directory.dir;
			}
		}
		else
		{
			result+="-rw";
			BOOL isexe=FALSE;
			CString ext=fn.Right(4);
			ext.MakeLower();
			if (ext.ReverseFind('.')!=-1)
			{
				if (ext==".exe")
					isexe=TRUE;
				else if (ext==".bat")
					isexe=TRUE;
				else if (ext==".com")
					isexe=TRUE;
			}
			result+=isexe?"x":"-";
			result+="r-";
			result+=isexe?"x":"-";
			result+="r-";
			result+=isexe?"x":"-";
		}
		result+="   1 ftp      ftp";
		CString size;
		size.Format("%d",find.GetLength());
		CString tmp="              ";
		result+=tmp.Left(tmp.GetLength()-size.GetLength());
		result+=size;
		CTime time=CTime::GetCurrentTime();
		find.GetLastWriteTime(time);
		CTimeSpan span=CTime::GetCurrentTime()-time;
		char months[][4]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
		tmp.Format(" %s %02d ",months[time.GetMonth()-1],time.GetDay());
		result+=tmp;
			
		if (span.GetDays()>356)
		{
			tmp.Format("%d ",time.GetYear());
			result+=tmp;
		}
		else
		{
			tmp.Format("%02d:%02d ",time.GetHour(),time.GetMinute());
			result+=tmp;
		}


		result+=fn;
		result+="\r\n";

		//Resize the memory for result if too small
		if (result.GetLength()>reflen)
		{
			reflen+=5000;
			result.GetBuffer(reflen);
			result.ReleaseBuffer();
		}
	}
	result.FreeExtra();
	return 0;
}

int CUsersDlg::GetRealDirectory(CString directory,int user,t_directory &ret,BOOL &truematch)
{
	int res=0;
	m_sync.Lock();
	BOOL bRelative=m_Users[user].bRelative;
	BOOL bLnk=m_Users[user].bLnk;
	m_sync.Unlock();
	CString realpath;
	directory.TrimLeft("/");
	directory.TrimRight("/");
	if (!bRelative)
	{
		directory.Replace("/","\\");
		if (directory.Right(1)==":")
			directory+="\\";
		//Check if the path is valid
		CFileStatus status;
		if (directory.Right(2)!=":\\")
		{
			if (CFile::GetStatus(directory,status))
			{
				if (!(status.m_attribute&0x10))
					return 6;
				realpath=directory;
			}
			else if (bLnk && CFile::GetStatus(directory+".lnk",status))
			{
				CString target=GetShortcutTarget(directory+".lnk");
				if (target.Right(2)!=":\\")
				{
					if (!CFile::GetStatus(target,status))
						return 2;
					else if (!(status.m_attribute&0x10))
						return 6; //4
				}
				realpath=target;				
			}
			else
				return 2;
		}
		else
			realpath=directory;
	}
	else
	{
		CStringList PathPieces;
		int pos;
		while((pos=directory.Find("/"))!=-1)
		{
			PathPieces.AddTail(directory.Left(pos));
			directory=directory.Mid(pos+1);
		}
		if (directory!="")
			PathPieces.AddTail(directory);
		
		//First get the home dir
		m_sync.Lock();
		for (int i=0;i<m_Users[user].permissions.GetSize();i++)
		{
			if (m_Users[user].permissions[i].bIsHome)
				break;
		}
		if (i==m_Users[user].permissions.GetSize())
		{
			m_sync.Unlock();
			return 1;
		}
		CString path=m_Users[user].permissions[i].dir;
		m_sync.Unlock();
	
		while(!PathPieces.IsEmpty())
		{
			CString piece=PathPieces.GetHead();
			PathPieces.RemoveHead();
			CFileStatus status;
			if (CFile::GetStatus(path+"\\"+piece,status))
			{
				if (!(status.m_attribute&0x10))
					return 6;
				path+="\\"+piece;
			}
			else if (m_Users[user].bLnk && CFile::GetStatus(path+"\\"+piece+".lnk",status))
			{
				if (status.m_attribute&0x10)
					return 6;
			
				CString target=GetShortcutTarget(path+"\\"+piece+".lnk");
				if (target=="")
					return 2;
				if (target.Right(2)!=":\\")
				{
					if (!CFile::GetStatus(target,status))
						return 2;
					if (!(status.m_attribute&0x10))
						return 6;
				}
				path=target;
			}
			else
				return 2;
		}
		realpath=path;
	}
	//We found a valid local path! Now find an matching path within the permissions
	m_sync.Lock();
	truematch=FALSE;
	CString path=realpath;
	while(path!="")
	{
		for (int i=0;i<m_Users[user].permissions.GetSize();i++)
		{
			CString path2=path;
			path2.TrimRight("\\");
			path2.MakeLower();
			CString path3=m_Users[user].permissions[i].dir;
			path3.TrimRight("\\");
			path3.MakeLower();
			if (path3==path2)
			{
				if (path==realpath)
					truematch=TRUE;
				break;
			}
		}
		if (i==m_Users[user].permissions.GetSize())
		{
			int pos=path.ReverseFind('\\');
			if (pos!=-1)
				path=path.Left(pos);
			else
			{
				m_sync.Unlock();
				return 1;
			}
			continue;
		}
		ret=m_Users[user].permissions[i];
		realpath.TrimRight('\\');
		ret.dir=realpath;
		m_sync.Unlock();
		return 0;
		
	}
	m_sync.Unlock();
	return 2;
}

int CUsersDlg::ChangeCurrentDir(CString user,CString &currentdir,CString &dir)
{
	//Reformat the directory
	dir.Replace("\\","/");
	while(dir.Replace("//","/"));
	dir.TrimRight("/");
	if (dir=="")
		dir="/";
	else
	{
		//Reassamble the path, remove the dots
		CStringList piecelist;
		int pos;
		if (dir.Left(1)!="/")
		{ //New relative path
		  //The current dir has to be added to the split into pieces
			CString tmp=currentdir;
			tmp.TrimRight("/");
			tmp.TrimLeft("/");
			while((pos=tmp.Find("/"))!=-1)
			{
				piecelist.AddTail(tmp.Left(pos));
				tmp=tmp.Mid(pos+1);
			}
			if (tmp!="")
				piecelist.AddTail(tmp);	
		}
		//Split the new path into pieces and add it to the piecelist
		dir.TrimLeft("/");
		while((pos=dir.Find("/"))!=-1)
		{
			piecelist.AddTail(dir.Left(pos));
			dir=dir.Mid(pos+1);
		}
		if (dir!="")
			piecelist.AddTail(dir);
		dir="";
		int remove=0; //Number of pieces that will be removed due to dots
		while (!piecelist.IsEmpty())
		{
			CString tmp=piecelist.GetTail();
			piecelist.RemoveTail();
			while (tmp.Left(2)=="..")
			{ //Oh, double dots found! Remove one piece
				remove++;
				tmp=tmp.Mid(1);
			}
			if (tmp!=".") //Skips single dots
			{
				if (remove) 
					remove--; //Don't add the piece
				else
					dir="/"+tmp+dir;
			}			
		}
		if (dir=="")
			dir="/";
	}
	//dir now is the absolute path (logical server path of cource)

	//Get userindex based on user string
	m_sync.Lock();
	for (int index=0;index<m_Users.GetSize();index++)
	{
		if (m_Users[index].user==user)
			break;
	}
	if (index==m_Users.GetSize())
		return 1; //No user found
	BOOL bRelative=m_Users[index].bRelative;
	m_sync.Unlock();
	
	//Get the physical path
	t_directory directory;
	BOOL truematch;
	int res=GetRealDirectory(dir,index,directory,truematch);
	if (res)
		return res;
	if (!directory.bDirList)
		return 1;
	if (!truematch && !directory.bDirSubdirs)
		return 1;
	//Finally, a valid path!
	if (bRelative)
		currentdir=dir; //Server paths are relative, so we can use the logical server path
	else
	{
		//No relative server path, we have to convert the physical path into a logical server path.
		directory.dir.Replace("\\","/");
		directory.dir.TrimRight("/");
		currentdir="/"+directory.dir;
	}
	return 0;
}

CString CUsersDlg::GetShortcutTarget(CString filename)
{
	CoInitialize(0);
	
	CString target;
	HRESULT hres;
	IShellLink *psl;
	char szGotPath [MAX_PATH];
	WIN32_FIND_DATA wfd;

	// Get a pointer to the IShellLink interface.
	hres = CoCreateInstance (CLSID_ShellLink, NULL,
	CLSCTX_INPROC_SERVER,
	IID_IShellLink, (void **)&psl);
	if (SUCCEEDED (hres))
	{
		IPersistFile *ppf;

		// Get a pointer to the IPersistFile interface.
		hres = psl->QueryInterface (IID_IPersistFile, (void
			**)&ppf);

		if (SUCCEEDED (hres))
		{
			WORD wsz [MAX_PATH]; // buffer for Unicode string

			// Ensure that the string consists of Unicode characters.
			MultiByteToWideChar (CP_ACP, 0, filename, -1, wsz,
			MAX_PATH);
			
			// Load the shortcut.
			hres = ppf->Load (wsz, STGM_READ);
			
			if (SUCCEEDED (hres))
			{
				// Resolve the shortcut.
				hres = psl->Resolve (0, SLR_ANY_MATCH|SLR_NO_UI);
				if (SUCCEEDED (hres))
				{
					strcpy (szGotPath, filename);
					// Get the path to the shortcut target.
					hres = psl->GetPath (szGotPath, MAX_PATH,
					(WIN32_FIND_DATA *)&wfd, 0);
					target=szGotPath;
				}
			}
			// Release the pointer to IPersistFile.
			ppf->Release ();
		}
		// Release the pointer to IShellLink.
		psl->Release ();
	}
	CoUninitialize();
	if (SUCCEEDED(hres))
		return target;
	else
		return "";
}

int CUsersDlg::GetFileName(CString user,CString filename,CString currentdir,int op,CString &result)
{
	//Reformat the directory
	filename.Replace("\\","/");
	while(filename.Replace("//","/"));
	filename.TrimRight("/");
	if (filename=="")
		return 2;
	else
	{
		//Reassamble the path, parse the dots
		CStringList piecelist;
		int pos;
		if (filename.Left(1)!="/")
		{ //New relative path
		  //The current dir has to be added to the split into pieces
			CString tmp=currentdir;
			tmp.TrimRight("/");
			tmp.TrimLeft("/");
			while((pos=tmp.Find("/"))!=-1)
			{
				piecelist.AddTail(tmp.Left(pos));
				tmp=tmp.Mid(pos+1);
			}
			if (tmp!="")
				piecelist.AddTail(tmp);	
		}
		//Split the new path into pieces and add it to the piecelist
		filename.TrimLeft("/");
		while((pos=filename.Find("/"))!=-1)
		{
			piecelist.AddTail(filename.Left(pos));
			filename=filename.Mid(pos+1);
		}
		if (filename!="")
			piecelist.AddTail(filename);
		filename="";
		int remove=0; //Number of pieces that will be removed due to dots
		while (!piecelist.IsEmpty())
		{
			CString tmp=piecelist.GetTail();
			piecelist.RemoveTail();
			while (tmp.Left(2)=="..")
			{ //Oh, double dots found! Remove one piece
				remove++;
				tmp=tmp.Mid(1);
			}
			if (tmp!=".") //Skips single dots
			{
				if (remove) 
					remove--; //Don't add the piece
				else
					filename="/"+tmp+filename;
			}			
		}
		if (filename=="")
			return 2;
	}
	CString dir;
	int pos=filename.ReverseFind('/');
	if (pos==-1)
		return 2;
	dir=filename.Left(pos);
	if (dir=="")
		dir="/";
	filename=filename.Mid(pos+1);

	//dir now is the absolute path (logical server path of course)
	//while filename is the filename

	//Get userindex based on user string
	m_sync.Lock();
	for (int index=0;index<m_Users.GetSize();index++)
	{
		if (m_Users[index].user==user)
			break;
	}
	if (index==m_Users.GetSize())
		return 1; //No user found
	BOOL bRelative=m_Users[index].bRelative;
	m_sync.Unlock();
	
	//Get the physical path
	t_directory directory;
	BOOL truematch;
	int res=GetRealDirectory(dir,index,directory,truematch);
	dir=directory.dir;
	result=dir+"\\"+filename;
	if (res)
		return res;
	if (!directory.bFileRead && op&FOP_READ)
		res|=1;
	if (!directory.bFileDelete && op&FOP_DELETE)
		res|=1;
	if (!directory.bFileAppend && op&FOP_APPEND)
		res|=1;
	if (!truematch && !directory.bDirSubdirs)
		res|=1;
	CFileStatus status;
	dir.TrimRight("\\");
	if (!CFile::GetStatus(dir+"\\"+filename,status))
	{
		res|=4;
		if (!directory.bFileWrite && op&FOP_WRITE)
			res|=1;
	}
	else if (status.m_attribute&0x10)
		res|=8;
	else if (!directory.bFileDelete && op&FOP_WRITE)
		res|=1;
	
	//If res is 0 we finally have a valid path+filename!
	return res;
}

int CUsersDlg::GetDirName(CString user,CString dirname,CString currentdir,int op,CString &result)
{
	//Reformat the directory
	dirname.Replace("\\","/");
	while(dirname.Replace("//","/"));
	dirname.TrimRight("/");
	if (dirname=="")
		return 2;
	else
	{
		//Reassamble the path, parse the dots
		CStringList piecelist;
		int pos;
		if (dirname.Left(1)!="/")
		{ //New relative path
		  //The current dir has to be added to the split into pieces
			CString tmp=currentdir;
			tmp.TrimRight("/");
			tmp.TrimLeft("/");
			while((pos=tmp.Find("/"))!=-1)
			{
				piecelist.AddTail(tmp.Left(pos));
				tmp=tmp.Mid(pos+1);
			}
			if (tmp!="")
				piecelist.AddTail(tmp);	
		}
		//Split the new path into pieces and add it to the piecelist
		dirname.TrimLeft("/");
		while((pos=dirname.Find("/"))!=-1)
		{
			piecelist.AddTail(dirname.Left(pos));
			dirname=dirname.Mid(pos+1);
		}
		if (dirname!="")
			piecelist.AddTail(dirname);
		dirname="";
		int remove=0; //Number of pieces that will be removed due to dots
		while (!piecelist.IsEmpty())
		{
			CString tmp=piecelist.GetTail();
			piecelist.RemoveTail();
			while (tmp.Left(2)=="..")
			{ //Oh, double dots found! Remove one piece
				remove++;
				tmp=tmp.Mid(1);
			}
			if (tmp!=".") //Skips single dots
			{
				if (remove) 
					remove--; //Don't add the piece
				else
					dirname="/"+tmp+dirname;
			}			
		}
		if (dirname=="")
			return 2;
	}

	CString dir;
	int pos=dirname.ReverseFind('/');
	if (pos==-1)
		return 2;
	dir=dirname.Left(pos);
	if (dir=="")
		dir="/";
	dirname=dirname.Mid(pos+1);

	//Get userindex based on user string
	m_sync.Lock();
	for (int index=0;index<m_Users.GetSize();index++)
	{
		if (m_Users[index].user==user)
			break;
	}
	if (index==m_Users.GetSize())
		return 1; //No user found
	BOOL bRelative=m_Users[index].bRelative;
	m_sync.Unlock();
	
	//Get the physical path, only of dir to get the right permissions
	t_directory directory;
	BOOL truematch;
	int res;
	do
	{
		res=GetRealDirectory(dir,index,directory,truematch);
		if (!(res&4) && res&2 && op==DOP_CREATE) 
		{ //that path could not be found. Maybe more than one directory level has to be created, check that
			int pos=dir.ReverseFind('/');
			ASSERT(pos!=-1);
			if (!pos) //We are already at the topmost level!
				return res;
			dirname=dir.Mid(pos+1)+"/"+dirname;
			dir=dir.Left(pos);
			continue;
		}
		else if (res) 
			return res;
		dir=directory.dir;
		if (!directory.bDirDelete && op&DOP_DELETE)
			res|=1;
		if (!directory.bDirCreate && op&DOP_CREATE)
			res|=1;
		if (!truematch && !directory.bDirSubdirs)
			res|=1;
		break;
	} while (dir!="/");

	//Check if dir+dirname is a valid path
	int res2=GetRealDirectory(dir+"//"+dirname,index,directory,truematch);
	result=directory.dir;
	if (!(res2&2))
		return res&res2;
	dirname.Replace("/","\\");
	result=dir+"\\"+dirname;
		
	//dir+dirname could no be found
	CFileStatus status;
	dir.TrimRight("\\");
	if (!CFile::GetStatus(dir+"\\"+dirname,status))
	{
		res|=4;
	}
	else if (!(status.m_attribute&0x10))
		res|=8;
	
	//Finally, a valid path+dirname!
	return res;
}

BOOL CUsersDlg::GetUser(const CString &user,t_user &userdata)
{
	m_sync.Lock();
	for (int i=0;i<m_Users.GetSize();i++)
	{
		if (m_Users[i].user==user)
		{
			userdata=m_Users[i];
			m_sync.Unlock();
			return TRUE;
		}
	}
	m_sync.Unlock();
	return FALSE;
}
