#if !defined(AFX_USERSDLG_H__5348112C_F36E_42D1_B073_78272B897DDA__INCLUDED_)
#define AFX_USERSDLG_H__5348112C_F36E_42D1_B073_78272B897DDA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UsersDlg.h : Header-Datei
//

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CUsersDlg 
typedef struct
{
	CString dir;
	BOOL bFileRead,bFileWrite,bFileDelete,bFileAppend;
	BOOL bDirCreate,bDirDelete,bDirList,bDirSubdirs,bIsHome;
} t_directory;


class t_user
{
public:
	CString user;
	CString password;
	CArray<t_directory,t_directory> permissions;
	BOOL bLnk,bRelative,bBypassUserLimit;
	int nUserLimit,nIpLimit;
	t_user& t_user::operator=(const t_user &a);
};

#define FOP_READ 1
#define FOP_WRITE 2
#define FOP_DELETE 4
#define FOP_APPEND 8
#define DOP_DELETE 16
#define DOP_CREATE 32

class CUsersDlg : public CDialog
{
// Konstruktion
public:
	BOOL GetUser(const CString &user,t_user &userdata);
	int ChangeCurrentDir(CString user,CString& currentdir,CString &dir);
	int GetDirectoryListing(CString user,CString dir,CString &result);
	int GetDirName(CString user,CString dirname,CString currentdir,int op,CString &result);
	int GetFileName(CString user,CString filename,CString currentdir,int op,CString &result);
	CString GetHomeDir(CString user);
	BOOL Lookup(const CString &user,const CString& pass,t_user &userdata);
	CUsersDlg(CWnd* pParent = NULL);   // Standardkonstruktor
	~CUsersDlg();

// Dialogfelddaten
	//{{AFX_DATA(CUsersDlg)
	enum { IDD = IDD_USERS };
	CEdit	m_cIpLimit;
	CEdit	m_cMaxConnCount;
	CButton	m_cMaxUsersBypass;
	CButton	m_cRelative;
	CButton	m_cLnk;
	CButton	m_cNeedpass;
	CComboBox	m_cGroup;
	CButton	m_cDirsCreate;
	CButton	m_cDirsDelete;
	CButton	m_cDirsList;
	CButton	m_cDirsSubdirs;
	CButton	m_cFilesRead;
	CButton	m_cFilesWrite;
	CButton	m_cFilesDelete;
	CButton	m_cFilesAppend;
	CListCtrl	m_cDirs;
	CListBox	m_cUserlist;
	CEdit	m_cPass;
	BOOL	m_bNeedpass;
	CString	m_Pass;
	BOOL	m_bDirsCreate;
	BOOL	m_bDirsDelete;
	BOOL	m_bDirsList;
	BOOL	m_bDirsSubdirs;
	BOOL	m_bFilesAppend;
	BOOL	m_bFilesDelete;
	BOOL	m_bFilesRead;
	BOOL	m_bFilesWrite;
	BOOL	m_bLnk;
	BOOL	m_bRelative;
	BOOL	m_bMaxUsersBypass;
	CString	m_MaxConnCount;
	CString	m_IpLimit;
	//}}AFX_DATA


// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CUsersDlg)
	public:
	virtual int DoModal();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	CString GetShortcutTarget(CString filename);
	int GetRealDirectory(CString directory,int user,t_directory &ret,BOOL &truematch);
	CImageList m_imagelist;
	void SetCtrlState();
	void SavePermissions(t_user &user);
	void ReadPermissions(t_user &user);
	int m_olduser;
	BOOL Validate();
	CString GetKey(CString subkey,CString keyname);
	void SetKey(CString subkey,CString keyname,CString value);
	BOOL GetDomainUsers(CString DomainKeyName);
	CCriticalSection m_sync;
	CArray<t_user,t_user&> m_Users;
	CArray<t_user,t_user&> m_UsersTmp;
	
	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CUsersDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnNeedpass();
	afx_msg void OnSelchangeUserlist();
	virtual void OnOK();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnUsermenuAdd();
	afx_msg void OnUsermenuRemove();
	afx_msg void OnUsermenuRename();
	afx_msg void OnItemchangedDirs(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangingDirs(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDirmenuAdd();
	afx_msg void OnDirmenuRemove();
	afx_msg void OnDirmenuRename();
	afx_msg void OnDirmenuSetashomedir();
	afx_msg void OnEndlabeleditDirs(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkDirs(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_USERSDLG_H__5348112C_F36E_42D1_B073_78272B897DDA__INCLUDED_
